
PROGRAM CMOSSAVE;

(* VERSION 1.00 POUR WINDOWS 16 BITS.

   COMPILATEUR          : BPW 7.0
   DATE DE CREATION     : 19-08-2005
   DERNIERE MISE A JOUR : 19-08-2005

   UTILITAIRE DE RESTAURATION DE LA CMOS AVEC LE CONTENU DU FICHIER DONT LE NOM EST PASSE COMME PARAMETRE *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses STRINGS,    (* CHAINES AZT *)
     WINTYPES,   (* CONSTANTES DE L'API *)
     WINPROCS,   (* API *)
     WINCRT;     (* MODE CONSOLE *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  VARIABLES GLOBALES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var i : Byte;                              (* INDEX DANS LA CMOS *)
    Attente : Word;                        (* COMPTEUR D'ATTENTE *)
    Buffer : Array [0..255] of Byte;       (* BUFFER D'ECRITURE DE LA CMOS *)
    NomFichier : Array [0..261] of Char;   (* NOM DU FICHIER *)
    Handle : Integer;                      (* HANDLE DU FICHIER *)
    NbBytesLus : Integer;                  (* NOMBRE DE BYTES LUS DANS LE FICHIER *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  StrCopy(WindowTitle,'Restauration CMOS');
  InitWinCRT;
  (* RECUPERATION DU NOM DE FICHIER *)
  Writeln('CMOSLoad 1.00 - LPJJl Software');
  WriteLn('Ce programme restaure la CMOS avec une image sauvegarde');
  WriteLn;
  if ParamCount > 0
     then
       begin
         StrPCopy(NomFichier,ParamStr(1));
         StrCat(NomFichier,'.dta');
         WriteLn('Nom du fichier : ',NomFichier);
         (* LECTURE DU FICHIER *)
         Write('   Lecture du fichier... ');
         Handle := _lOpen(NomFichier,of_ReadWrite or of_Share_Exclusive);
         if Handle <> -1
            then
              begin
                FillChar(Buffer,SizeOf(Buffer),0);
                NbByteslus := _lRead(Handle,pChar(@Buffer),SizeOf(Buffer));
                if NbBytesLus = SizeOf(Buffer)
                   then   (* RESTAURATION DE LA CMOS *)
                     begin
                       WriteLn('OK');
                       Write('   Restauration de la CMOS... ');
                       for i := 0 to 127 do
                         begin
                           Port[$70] := i;
                           Attente := 10000;
                           while Attente > 0 do
                             Dec(Attente);
                           Port[$71] := Buffer[i];
                           Attente := 10000;
                           while Attente > 0 do
                             Dec(Attente);
                         end;
                       for i := 0 to 127 do
                         begin
                           Port[$72] := i;
                           Attente := 10000;
                           while Attente > 0 do
                             Dec(Attente);
                           Port[$73] := Buffer[i + 128];
                           Attente := 10000;
                           while Attente > 0 do
                             Dec(Attente);
                         end;
                       WriteLn('OK');
                     end
                   else
                     WriteLn('erreur de lecture');
                _lClose(Handle);
              end
            else
              WriteLn('erreur d''ouverture ou type de fichier incorrect');
       end
     else
       begin
         WriteLn('Le nom du fichier (sans extension) doit tre pass comme paramtre.');
         WriteLn('Exemple de ligne de commande : C:>cmosload image1');
         WriteLn('  (pour charger le fichier image1.dta)');
       end;
  WriteLn;
  Write('Pressez ENTER pour quitter : ');
  ReadLn;
  DoneWinCRT;
END.
