
PROGRAM CMOSSAVE;

(* VERSION 1.00 POUR WINDOWS 16 BITS.

   COMPILATEUR          : BPW 7.0
   DATE DE CREATION     : 19-08-2005
   DERNIERE MISE A JOUR : 19-08-2005

   UTILITAIRE DE SAUVEGARDE DU CONTENU DE LA CMOS DANS UN FICHIER DONT LE NOM EST DEFINI PAR L'UTILISATEUR *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses STRINGS,    (* CHAINES AZT *)
     WINPROCS,   (* API *)
     WINCRT;     (* MODE CONSOLE *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  VARIABLES GLOBALES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var i : Byte;                              (* INDEX DANS LA CMOS *)
    Attente : Word;                        (* COMPTEUR D'ATTENTE *)
    Buffer : Array [0..255] of Byte;       (* BUFFER DE LECTURE DE LA CMOS *)
    NomFichier : Array [0..261] of Char;   (* NOM DU FICHIER DE SAUVEGARDE *)
    Handle : Integer;                      (* HANDLE DU FICHIER *)
    NbBytesEcrits : Integer;               (* NOMBRE DE BYTES ECRITS DANS LE FICHIER *)

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  StrCopy(WindowTitle,'Sauvegarde CMOS');
  InitWinCRT;
  (* DEMANDE DU NOM DE FICHIER *)
  WriteLn('CMOSSave 1.00 - LPJJl Software');
  WriteLn('Ce programme va sauvegarder le contenu de la CMOS dans un fichier.');
  WriteLn;
  Write('Nom du fichier (sans extension, SVP) : ');
  ReadLn(NomFichier);
  StrCat(NomFichier,'.dta');
  (* LECTURE OCTET PAR OCTET *)
  Write('   Lecture de la CMOS... ');
  FillChar(Buffer,SizeOf(Buffer),0);
  for i := 0 to 127 do
    begin
      Port[$70] := i;
      Attente := 10000;
      while Attente > 0 do
        Dec(Attente);
      Buffer[i] := Port[$71];
    end;
  for i := 0 to 127 do
    begin
      Port[$72] := i;
      Attente := 10000;
      while Attente > 0 do
        Dec(Attente);
      Buffer[i + 128] := Port[$73];
    end;
  WriteLn('OK');
  (* SAUVEGARDE DU FICHIER *)
  Write('   Sauvegarde... ');
  Handle := _lCreat(NomFichier,0);
  if Handle <> -1
     then
       begin
         NbBytesEcrits := _lWrite(Handle,pChar(@Buffer),SizeOf(Buffer));
         if NbBytesEcrits = SizeOf(Buffer)
            then
              begin
                if _lClose(Handle) <> -1
                   then
                     begin
                       WriteLn('OK');
                       WriteLn('   L''utilitaire CMOSLoad peut restaurer l''image que vous venez de sauvegarder.');
                     end
                   else
                     WriteLn('erreur de fermeture du fichier');
              end
            else
              begin
                WriteLn('erreur d''criture dans le fichier');
                _lClose(Handle);
              end;
       end
     else
       WriteLn('erreur de cration du fichier');
  WriteLn;
  Write('Pressez ENTER pour quitter : ');
  ReadLn;
  DoneWinCRT;
END.
